



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>再识C中的结构体</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">再识C中的结构体</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 12:15:25 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　在前面<a href="http://www.cnblogs.com/zhouxuanyu/p/4512944.html" rel="external nofollow noreferrer">认识C中的结构体</a>中我介绍了结构体的基础知识，下面通过这段代码来回顾一下：</p>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;<br />
 #define LEN 20

 struct Student{            //定义结构体<br />
     char name[LEN];<br />
     char address[LEN];<br />
     int age;<br />
 };

 int main(int argc, char* argv[])<br />
 {<br />
     struct Student s = {        //初始化<br />
         "bluemsun","NENU",<br />
     };    

     struct Student * p;            //定义一个指向结构体的指针<br />
     p = &amp;s;                        //为指针赋值

     printf("s.name = %s,s.address = %s,s.age = %d\n",s.name,s.address,s.age);<br />
     printf("p-&gt;name = %s,p-&gt;address = %s,p-&gt;age = %d\n",p-&gt;name,p-&gt;address,p-&gt;age);<br />
 }</pre>
</div>
<p>　　这是一个比较简单的例子程序，在结构体Student中我们定义两个char数组，现在来考虑这样一个问题。我们在平时需要使用数组的时候都是可以用指针代替数组作为参数使用，那么在上面的程序中能否用下面这段代码代替结构体的定义呢？</p>
<div>
<pre class="prettyprint linenums"> struct new_Student{            //定义结构体<br />
     char * name;<br />
     char * address;<br />
     int age;<br />
 };</pre>
</div>
<p>　　答案是肯定的，但是可能会遇到一些麻烦。考虑下面一段代码：</p>
<div>
<pre class="prettyprint linenums"> struct new_Student s1 = {"zhouxy","EFGH",};<br />
 struct Student s2 = {"bluemsun","ABCD",};    </pre>
</div>
<p>　　这段代码是正确的。但是想想其中的字符串存储在哪里？对于struct Student变量s2来说，字符串存储在结构内部，这个结构总共分配了40个字节来存储两个字符串。然而对于new_Student变量s1来说，字符串是存放在编译器存储字符串常量的任何地方。new_Student结构中仅仅是存放了两个地址而已。所以如果需要一个结构来存放字符串，请使用字符数组成员。那么是不是采用指针的方式就真的不能完成内存的分配呢？答案是否定的。<a href="http://www.cnblogs.com/zhouxuanyu/p/4508641.html" rel="external nofollow noreferrer">在这里</a>我讲解了关于C中的函数malloc()，这个函数是可以在运行期动态分配内存的。所以如果能结合在这里来使用，那就达到了我们的设想了。考虑下面这段代码：</p>
<div>
<pre class="prettyprint linenums"> #include&lt;stdio.h&gt;<br />
 #include&lt;string.h&gt;<br />
 #include&lt;stdlib.h&gt;

 struct new_Student{            //定义结构体<br />
     char * name;<br />
     char * address;<br />
     int age;<br />
 };

 int main(int argc, char* argv[])<br />
 {<br />
     char str[] = "zhouxy";<br />
     struct new_Student s1;<br />
     //分配用来存放名字的内存<br />
     s1.name = (char*)malloc(strlen(str)+);<br />
     //把名字复制到已分配的内存中<br />
     strcpy(s1.name,str);

     printf("s1.name = %s\n",s1.name);<br />
 }</pre>
</div>
<p>　　上面代码是正确的，我们用malloc()函数分配存储空间，然后把字符串复制到新分配的空间。这里要理解的是：name字符串不是被存储在结构中，而是被保存在由malloc()函数管理的内存中。结构中仅仅是保存了name字符串的地址而已。还有一点要记得的是：我们使用malloc()函数分配内存之后要调用free()函数，不然可能会引起"内存泄露"。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4k3je9.html">Dos学习笔记（3）attrib命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9jgprg9.html">wamp 中如何管理两个dedeCms站点</a>
		</li>
						<li><a href="https://www.batexi.com/a/3900vdm9.html">iOS 文件大小转换成 KB、MB、GB 。。。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k104169.html">项目管理：CocoaPods建立私有仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0mg40q.html">java clone简单学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv0m71q.html">8个web前端的精美HTML5 &amp;amp&semi; CSS3效果及源码下载</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1lopv9.html">java推断字符串是否为乱码</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vnyxj8.html">MarkDown教程</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xl4gz8.html">iOS中默认样式修改－b</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1zjvk8.html">Unity问答&mdash;&mdash;怎么知道屏幕中目前有多少个敌人？</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m5my1q.html">Python学习笔记六--文件和输入输出</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1ngnj9.html">日志管理-将Log4net的配置配置到的独立文件中</a>
		</li>
						<li><a href="https://www.batexi.com/a/950g0om8.html">UVa 740 - Baudot Data Communication Code</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ey4ree9.html">SQLServer 分组查询相邻两条记录的时间差</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1271jq.html">&period;Net多线程编程&mdash;Parallel LINQ、线程池</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7znnlj9.html">smarty fetch方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlxpl8.html">orcFile split和读数据原理总结（hive0&period;13）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjgwoz9.html">&lbrack;c&sol;c&plus;&plus;&rsqb; programming之路（23）、字符串（四）&mdash;&mdash;strncat，atoi，strcmp，strlen等，以及常用内存函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdznd09.html">http 文件上传协议图览</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j6k7nq.html">【Spring】12、Spring Security 四种使用方式</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qn12ldx8.html">第三百四十八天 how can I 坚持</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wm6pvq.html">细说OpenSessionInView问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/8k1n47r9.html">支付结果回调v7核心&comma;投保确认接口&period;&period;</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wmvovq.html">Java模板引擎 FreeMarker</a>
			</li>
						<li><a href="https://www.batexi.com/a/qyd4lg2q.html">chrome浏览器插件window resizer调试webapp页面大小</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vjng38.html">Python基础 初识Python</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnl72pq.html">ASP&period;NET MVC-  DropDownList绑定</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvvzm0yq.html">Plan04&period;学习与提升</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vj3w38.html">Hibernate&plus;Struts2完成修改数据功能</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1zp1109.html">inline-block 前世今生</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
